(* ------------------------------------------------------ *)
(*                     HEADER.PAS                         *)
(*           Deklarationsteil von RECURSE.PAS             *)
(* ------------------------------------------------------ *)
UNIT    header;

INTERFACE

USES    dos;

CONST                            (* allgemeine Konstanten *)
        NAMELEN       = 20;
        TEXTLEN       = 80;
        MAXPATTERN    = 20;
        DEFAULT_DELAY =  0;
        WORK_MARGIN   =  8;
        MAIN_MARGIN   =  4;
        FAIL_MARGIN   = 10;

        CURSOR_OFF    = $2000   ;
        OUTPUT_DELAY  : word    =  $0A;
        recursive     : BOOLEAN = TRUE;
        is_echo       : BOOLEAN = TRUE;
        COPY_RIGHT    = '(c) 1988 by F&C PRODUCTS ';

TYPE    nameline      = STRING[NAMELEN];
        textline      = STRING[TEXTLEN];
        patt_arr      = ARRAY [1..MAXPATTERN] OF nameline;

   (* der order_typ gibt den Status des Programms wieder: *)
   (*          work_    -> Parameter-Analyse erfolgreich  *)
   (*          param_   -> falsche / unbekannte Parameter *)
   (*          info_    -> HILFE angefordert              *)
   (*          pattern_ -> falsche / verbotene Pattern    *)
   (*          missing_ -> keine Parameter angegeben      *)

        order_typ     = (work_,  param_,  info_,
                         pattern_,  missing_    );

VAR     pattern       : patt_arr ;     (* die Suchpattern *)
        parameters    : BYTE     ;
        start_path    : textline ;
        regs          : registers;
        DOScursor     : word     ;

{$IFDEF clean_recurse}
     (* bedingt compilierte Variablen, Typen + Konstanten *)

  CONST PROG_NAME     = 'CLEAN';
        PROG_JOB      = ' lscht rekursiv ';
        tmp_on        : BOOLEAN = FALSE;
        norton_on     : BOOLEAN = TRUE ;
        turbo_on      : BOOLEAN = TRUE ;
        obj_on        : BOOLEAN = FALSE;
        map_on        : BOOLEAN = FALSE;
        unit_on       : BOOLEAN = FALSE;

  VAR   deletefile    : TEXT    ;

{$ELSE}
  {$IFDEF dir_recurse}

  CONST PROG_NAME     = 'RDIR';
        PROG_JOB      = ' rekursives Directory von ';
        time_on       : BOOLEAN = TRUE ;
        date_on       : BOOLEAN = TRUE ;
        size_on       : BOOLEAN = TRUE ;
        attr_on       : BOOLEAN = FALSE;

  {$ELSE}

  (*        der Kompiler soll abbrechen, ...              *)
  (*    FEHLER ---> DEFINE fr bedingte Compilation       *)
  (*                vermisst oder falsch !!!              *)
  (*    ... wenn der USER kein $DEFINE gemacht hat!       *)

  {$ENDIF}
{$ENDIF}

(* ------------------------------------------------------ *)
IMPLEMENTATION

BEGIN                  (* Initialisierung der Suchpattern *)
  FillChar(pattern,SizeOf(pattern),#0);
END.
(* ------------------------------------------------------ *)
(*                   Ende von HEADER.PAS                  *)
